/*
 * Astri_Monitor.h
 *
 *  Created on: Jul 3, 2021
 *      Author: astrisw
 */

#ifndef INCLUDE_ASTRI_MONITOR_H_
#define INCLUDE_ASTRI_MONITOR_H_

#include <Base_Monitor.h>
#include <chrono>
#include <unordered_map>


class AstriMonitor : public BaseMonitor{

	private:
	long long int num_pack_rcv;
		long long int num_pack_lost;
		long long int num_pack_invalid;
		long long int num_byte_rcv;
		std::chrono::duration<double, std::milli> timeElps;
		std::chrono::steady_clock::time_point startTime;
		std::unordered_map<std::string, long long int> sscMap;

	protected:
		bool monitTotPacketsFlag;
		bool monitPacketLostFlag;
		bool monitInvalidPacketsFlag ;
		bool monitTimeFlag;
		bool monitByteFlag;

		void monitPacketLost(BasePacket &pack);
		void monitTotPackets();
		void monitByte(BasePacket &pack);
		void monitInvalidPackets(BasePacket &pack);
		void monitTime();


	public:
		AstriMonitor();
		AstriMonitor(bool monitNumPackets, bool monitLost, bool monitInvalid, bool monitTime, bool monitByte);
		void monit(BasePacket &pack);

		void setMonitTotPacketsFlag(bool val){this->monitTotPacketsFlag = val;}
		void setmonitPacketLostFlag(bool val){this->monitPacketLostFlag = val;}
		void setMonitInvalidPacketsFlag (bool val){this->monitInvalidPacketsFlag = val;}
		void setMonitTimeFlag(bool val){this->monitTimeFlag = val;}
		void setMonitByteFlag(bool val){this->monitByteFlag = val;}


		void reset();
		void printStats();

};

#endif /* INCLUDE_ASTRI_MONITOR_H_ */
