
#ifndef ASTRIMONITORCONFIGURATOR_H_
#define ASTRIMONITORCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Astri_Monitor.h>



class AstriMonitorConfigurator : public BaseConfigurator{

public:
	AstriMonitorConfigurator(int argc, char **argv);
	AstriMonitorConfigurator();

	void setMonitNumPacket(bool val){this->params["numPackets"] = val ? "true" : "false";}
	void setMonitLostPacket(bool val){this->params["lost"] = val ? "true" : "false";}
	void setMonitInvalidPacket(bool val){this->params["invalid"] = val ? "true" : "false";}
	void setMonitTime(bool val){this->params["time"] = val ? "true" : "false";}
	void setMonitByte(bool val){this->params["byte"] = val ? "true" : "false";}

	bool isMonitNumPacket();
	bool isMonitLostPacket();
	bool isMonitInvalidPacket();
	bool isMonitTime();
	bool isMonitByte();


	BaseMonitor * createMonitor();
	AstriMonitor* createAstriMonitor();
	void createAstriMonitor(AstriMonitor &);

	void printConfiguration(){
		std::string confStr = "Monitor Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

};

#endif
